package source
{
	import flash.display.BitmapData;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.masks.Pixelmask;
	import net.flashpunk.FP;
	import flash.geom.Point;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	/**
	 * ...
	 * @author Time
	 */
	public class Pixel extends Entity
	{
		private var s:Point = new Point(Math.random() * 2 - 1, Math.random() * 2 - 1);
		
		public var bmp:BitmapData = new BitmapData(3, 3, true, 0x00000000);
		private var mass:int = 1;
		
		private var xpos:Number;
		private var ypos:Number;
		
		private var totals:Point = new Point(1, 1);
		
		public function Pixel(_x:int, _y:int) 
		{
			super(_x, _y);
			
			xpos = _x;
			ypos = _y;
			
			Draw.setTarget(bmp);
			if (FP.choose(0, 0, 0, 1))
			{
				bmp.dispose();
				var _size:int = Math.ceil(Math.random() * 9);
				bmp = new BitmapData(_size, _size, true, 0x00000000);
				Draw.setTarget(bmp);
				Draw.linePlus(0, 0, _size, 0, genRandCol(), Math.random() / 2 + 1 / 2);
				Draw.linePlus(0, 0, 0, _size, genRandCol(), Math.random() / 2 + 1 / 2);
				Draw.linePlus(_size-1, 0, _size-1, _size, genRandCol(), Math.random() / 2 + 1 / 2);
				Draw.linePlus(0, _size-1, _size, _size-1, genRandCol(), Math.random() /2 + 1/2);
			}
			else if (FP.choose(0, 0, 0, 1))
			{
				bmp.dispose();
				var _size:int = Math.ceil(Math.random() * 9);
				bmp = new BitmapData(_size, _size, true, 0x00000000);
				Draw.setTarget(bmp);
				Draw.linePlus(0, 0, _size, _size, genRandCol(), Math.random() / 2 + 1 / 2);
			}
			else if (FP.choose(0, 0, 0, 1))
			{
				bmp.dispose();
				_size = Math.ceil(Math.random() * 9);
				bmp = new BitmapData(_size, _size, true, 0x00000000);
				Draw.setTarget(bmp);
				Draw.linePlus(_size, 0, 0, _size, genRandCol(), Math.random() / 2 + 1 / 2);
			}
			else if (FP.choose(0, 0, 1))
			{
				Draw.rect(1, 0, 1, 3, genRandCol(), Math.random()/2 + 1/2);
				Draw.rect(0, 1, 3, 1, genRandCol(), Math.random()/2 + 1/2);
			}
			else if(FP.choose(0,1))
			{
				Draw.rect(1, 1, 1, 1, 0x0000FF, Math.random()/2 + 1/2);
			}
			else
			{
				bmp.dispose();
				_size = Math.ceil(Math.random() * 9);
				bmp = new BitmapData(_size, _size, true, 0x00000000);
				Draw.setTarget(bmp);
				Draw.rect(0, 0, _size, _size, genRandCol(), Math.random() * 7 / 8 + 1/8);
			}
			
			Draw.resetTarget();
			
			mask = new Pixelmask(bmp);
			
			type = "Solid";
		}
		
		override public function update():void
		{
			xpos += s.x / Math.pow(mass, 0.25) * 3;
			ypos += s.y / Math.pow(mass, 0.25) * 3;
			
			if (xpos < FP.camera.x)
			{
				xpos = FP.camera.x;
				s.x = -s.x;
			}
			if (ypos < FP.camera.y)
			{
				ypos = FP.camera.y;
				s.y = -s.y;
			}
			if (xpos + bmp.width >= FP.camera.x + FP.width)
			{
				xpos = FP.camera.x + FP.width - bmp.width;
				s.x = -s.x;
			}
			if (ypos + bmp.height >= FP.camera.x + FP.height)
			{
				ypos = FP.camera.y + FP.height - bmp.height;
				s.y = -s.y;
			}
			
			x = Math.round(xpos);
			y = Math.round(ypos);
			
			var c:Pixel = collide("Solid", x+1, y) as Pixel;
			checkAddNew(c);
			c = collide("Solid", x-1, y) as Pixel;
			checkAddNew(c);
			c = collide("Solid", x, y+1) as Pixel;
			checkAddNew(c);
			c = collide("Solid", x, y-1) as Pixel;
			checkAddNew(c);
			
			if (Input.check(Key.C) && Input.mouseDown)
			{
				var mRad:int = 25;
				Draw.setTarget(bmp);
				bmp.fillRect(new Rectangle(Input.mouseX - mRad - xpos, Input.mouseY - mRad - ypos, 2 * mRad, 2 * mRad), 0x00000000);
				Draw.resetTarget();
				mask = new Pixelmask(bmp);
			}
		}
		
		public function checkAddNew(c:Pixel):void
		{
			if (c)
			{
				if (c.mass > mass)
				{
					c.addNew(this);
				}
				else
				{
					addNew(c);
				}
			}
		}
		
		public function genRandCol():uint
		{
			return FP.getColorRGB(Math.random() * 192, Math.random() * 192, Math.random() * 192);
		}
		
		public function addNew(p:Pixel):void
		{
			s.x += p.s.x / mass;
			s.y += p.s.y / mass;
			
			mass += p.mass;
			
			var l:int = 0;
			var u:int = 0;
			var r:int = 0;
			var d:int = 0;
			
			if (p.x < x)
			{
				l = x - p.x;
			}			
			if (p.x + p.bmp.width >= x + bmp.width)
			{
				r = p.x + p.bmp.width - x - bmp.width;
			}
			if (p.y < y)
			{
				u = y - p.y;
			}
			if (p.y + p.bmp.height >= y + bmp.height)
			{
				d = p.y + p.bmp.height - y - bmp.height;
			}
			
			var rect:Rectangle = new Rectangle(0, 0, bmp.width + l + r, bmp.height + u + d);
			
			var bmp_t:BitmapData = new BitmapData(rect.width, rect.height, true, 0x00000000);
			var m:Matrix = new Matrix();
			m.translate(l, u);
			bmp_t.draw(bmp, m);
			m = new Matrix();
			m.translate(p.x - x + l, p.y - y + u);
			bmp_t.draw(p.bmp, m);
			bmp.dispose();
			bmp = bmp_t.clone();
			bmp_t.dispose();
			
			xpos -= l;
			ypos -= u;
			x -= l;
			y -= u;
			
			mask = new Pixelmask(bmp);
			
			p.collidable = false;
			FP.world.remove(p);
		}
		
		override public function render():void
		{
			var m:Matrix = new Matrix();
			m.translate(xpos, ypos);
			FP.buffer.draw(bmp, m);
		}
		
	}

}